searchNodes=[{"type":"task","title":"Mix.Tasks.Sobelow","doc":"Sobelow is a static analysis tool for discovering vulnerabilities in Phoenix applications. This tool should be run in the root of the project directory with the following command: mix sobelow Command line options --root -r - Specify application root directory --verbose -v - Print vulnerable code snippets --ignore -i - Ignore modules --ignore-files - Ignore files --details -d - Get module details --all-details - Get all module details --private - Skip update checks --strict - Exit when bad syntax is encountered --mark-skip-all - Mark all printed findings as skippable --clear-skip - Clear configuration added by --mark-skip-all --skip - Skip functions flagged with #sobelow_skip or tagged with --mark-skip-all --router - Specify router location --exit - Return non-zero exit status --threshold - Only return findings at or above a given confidence level --format - Specify findings output format --quiet - Return no output if there are no findings --compact - Minimal, single-line findings --save-config - Generates a configuration file based on command line options --config - Run Sobelow with configuration file --version - Output current version of Sobelow Ignoring modules If specific modules, or classes of modules are not relevant to the scan, it is possible to ignore them with a comma-separated list. mix sobelow - i XSS.Raw , Traversal Supported modules XSS XSS.Raw XSS.SendResp XSS.ContentType XSS.HTML SQL SQL.Query SQL.Stream Config Config.CSRF Config.Headers Config.CSP Config.HTTPS Config.HSTS Config.Secrets Config.CSWH Vuln Vuln.CookieRCE Vuln.HeaderInject Vuln.PlugNull Vuln.Redirect Vuln.Coherence Vuln.Ecto Traversal Traversal.SendFile Traversal.FileModule Traversal.SendDownload Misc Misc.BinToTerm Misc.FilePath RCE.EEx RCE.CodeModule CI CI.System CI.OS DOS DOS.StringToAtom DOS.ListToAtom DOS.BinToAtom","ref":"Mix.Tasks.Sobelow.html"},{"type":"function","title":"Mix.Tasks.Sobelow.main/1","doc":"","ref":"Mix.Tasks.Sobelow.html#main/1"},{"type":"function","title":"Mix.Tasks.Sobelow.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Sobelow.html#run/1"},{"type":"function","title":"Mix.Tasks.Sobelow.run_diff/1","doc":"","ref":"Mix.Tasks.Sobelow.html#run_diff/1"},{"type":"function","title":"Mix.Tasks.Sobelow.set_env/2","doc":"","ref":"Mix.Tasks.Sobelow.html#set_env/2"},{"type":"module","title":"Sobelow","doc":"Sobelow is a static analysis tool for discovering vulnerabilities in Phoenix applications.","ref":"Sobelow.html"},{"type":"function","title":"Sobelow.all_details/0","doc":"","ref":"Sobelow.html#all_details/0"},{"type":"function","title":"Sobelow.details/0","doc":"","ref":"Sobelow.html#details/0"},{"type":"function","title":"Sobelow.finding_modules/0","doc":"","ref":"Sobelow.html#finding_modules/0"},{"type":"function","title":"Sobelow.format/0","doc":"","ref":"Sobelow.html#format/0"},{"type":"function","title":"Sobelow.get_env/1","doc":"","ref":"Sobelow.html#get_env/1"},{"type":"function","title":"Sobelow.get_ignored/0","doc":"","ref":"Sobelow.html#get_ignored/0"},{"type":"function","title":"Sobelow.get_mod/1","doc":"","ref":"Sobelow.html#get_mod/1"},{"type":"function","title":"Sobelow.is_vuln?/1","doc":"","ref":"Sobelow.html#is_vuln?/1"},{"type":"function","title":"Sobelow.log_finding/1","doc":"","ref":"Sobelow.html#log_finding/1"},{"type":"function","title":"Sobelow.log_finding/2","doc":"","ref":"Sobelow.html#log_finding/2"},{"type":"function","title":"Sobelow.loggable?/2","doc":"","ref":"Sobelow.html#loggable?/2"},{"type":"function","title":"Sobelow.meets_threshold?/1","doc":"","ref":"Sobelow.html#meets_threshold?/1"},{"type":"function","title":"Sobelow.output_format/0","doc":"","ref":"Sobelow.html#output_format/0"},{"type":"function","title":"Sobelow.rules/0","doc":"","ref":"Sobelow.html#rules/0"},{"type":"function","title":"Sobelow.run/0","doc":"","ref":"Sobelow.html#run/0"},{"type":"function","title":"Sobelow.save_config/1","doc":"","ref":"Sobelow.html#save_config/1"},{"type":"function","title":"Sobelow.version/0","doc":"","ref":"Sobelow.html#version/0"},{"type":"module","title":"Sobelow.CI","doc":"Command Injection Command Injection vulnerabilities are a result of passing untrusted input to an operating system shell, and may result in complete system compromise. Read more about Command Injection here: https://www.owasp.org/index.php/Command_Injection If you wish to learn more about the specific vulnerabilities found within the Command Injection category, you may run the following commands to find out more: $ mix sobelow - d CI.OS $ mix sobelow - d CI.System Command Injection checks of all types can be ignored with the following command: $ mix sobelow -i CI","ref":"Sobelow.CI.html"},{"type":"function","title":"Sobelow.CI.details/0","doc":"","ref":"Sobelow.CI.html#details/0"},{"type":"function","title":"Sobelow.CI.finding_modules/0","doc":"","ref":"Sobelow.CI.html#finding_modules/0"},{"type":"function","title":"Sobelow.CI.get_vulns/4","doc":"","ref":"Sobelow.CI.html#get_vulns/4"},{"type":"function","title":"Sobelow.CI.rules/0","doc":"","ref":"Sobelow.CI.html#rules/0"},{"type":"module","title":"Sobelow.CI.OS","doc":"Command Injection in :os.cmd This submodule of the CI module checks for Command Injection vulnerabilities through usage of the :os.cmd function. Ensure the the command passed to :os.cmd is not user-controlled. :os.cmd Injection checks can be ignored with the following command: $ mix sobelow -i CI.OS","ref":"Sobelow.CI.OS.html"},{"type":"function","title":"Sobelow.CI.OS.details/0","doc":"","ref":"Sobelow.CI.OS.html#details/0"},{"type":"function","title":"Sobelow.CI.OS.id/0","doc":"","ref":"Sobelow.CI.OS.html#id/0"},{"type":"function","title":"Sobelow.CI.OS.parse_def/1","doc":"","ref":"Sobelow.CI.OS.html#parse_def/1"},{"type":"function","title":"Sobelow.CI.OS.rule/0","doc":"","ref":"Sobelow.CI.OS.html#rule/0"},{"type":"function","title":"Sobelow.CI.OS.run/2","doc":"","ref":"Sobelow.CI.OS.html#run/2"},{"type":"module","title":"Sobelow.CI.System","doc":"Command Injection in System.cmd This submodule of the CI module checks for Command Injection vulnerabilities through usage of the System.cmd function. Ensure the the command passed to System.cmd is not user-controlled. System.cmd Injection checks can be ignored with the following command: $ mix sobelow -i CI.System","ref":"Sobelow.CI.System.html"},{"type":"function","title":"Sobelow.CI.System.details/0","doc":"","ref":"Sobelow.CI.System.html#details/0"},{"type":"function","title":"Sobelow.CI.System.id/0","doc":"","ref":"Sobelow.CI.System.html#id/0"},{"type":"function","title":"Sobelow.CI.System.parse_def/1","doc":"","ref":"Sobelow.CI.System.html#parse_def/1"},{"type":"function","title":"Sobelow.CI.System.rule/0","doc":"","ref":"Sobelow.CI.System.html#rule/0"},{"type":"function","title":"Sobelow.CI.System.run/2","doc":"","ref":"Sobelow.CI.System.html#run/2"},{"type":"module","title":"Sobelow.Config","doc":"Configuration Submodules contained within this vulnerability type are related to common insecurities found in how Phoenix applications are configured. This can include things like missing headers, insecure cookies, and more. If you wish to learn more about the specific vulnerabilities found within the Configuration category, you may run the following commands to find out more: $ mix sobelow - d Config.CSP $ mix sobelow - d Config.CSRF $ mix sobelow - d Config.CSRFRoute $ mix sobelow - d Config.CSWH $ mix sobelow - d Config.Headers $ mix sobelow - d Config.Secrets $ mix sobelow - d Config.HTTPS $ mix sobelow - d Config.HSTS Configuration checks of all types can be ignored with the following command: $ mix sobelow -i Config","ref":"Sobelow.Config.html"},{"type":"function","title":"Sobelow.Config.details/0","doc":"","ref":"Sobelow.Config.html#details/0"},{"type":"function","title":"Sobelow.Config.fetch/3","doc":"","ref":"Sobelow.Config.html#fetch/3"},{"type":"function","title":"Sobelow.Config.finding_modules/0","doc":"","ref":"Sobelow.Config.html#finding_modules/0"},{"type":"function","title":"Sobelow.Config.get_configs/2","doc":"","ref":"Sobelow.Config.html#get_configs/2"},{"type":"function","title":"Sobelow.Config.get_configs_by_file/2","doc":"","ref":"Sobelow.Config.html#get_configs_by_file/2"},{"type":"function","title":"Sobelow.Config.get_fuzzy_configs/2","doc":"","ref":"Sobelow.Config.html#get_fuzzy_configs/2"},{"type":"function","title":"Sobelow.Config.get_pipelines/1","doc":"","ref":"Sobelow.Config.html#get_pipelines/1"},{"type":"function","title":"Sobelow.Config.get_plug_accepts/1","doc":"","ref":"Sobelow.Config.html#get_plug_accepts/1"},{"type":"function","title":"Sobelow.Config.get_plug_list/1","doc":"","ref":"Sobelow.Config.html#get_plug_list/1"},{"type":"function","title":"Sobelow.Config.get_version/1","doc":"","ref":"Sobelow.Config.html#get_version/1"},{"type":"function","title":"Sobelow.Config.get_version/2","doc":"","ref":"Sobelow.Config.html#get_version/2"},{"type":"function","title":"Sobelow.Config.is_plug?/2","doc":"","ref":"Sobelow.Config.html#is_plug?/2"},{"type":"function","title":"Sobelow.Config.is_vuln_pipeline?/2","doc":"","ref":"Sobelow.Config.html#is_vuln_pipeline?/2"},{"type":"function","title":"Sobelow.Config.parse_accepts/1","doc":"","ref":"Sobelow.Config.html#parse_accepts/1"},{"type":"function","title":"Sobelow.Config.rules/0","doc":"","ref":"Sobelow.Config.html#rules/0"},{"type":"module","title":"Sobelow.Config.CSP","doc":"Missing Content-Security-Policy Content-Security-Policy is an HTTP header that helps mitigate a number of attacks, including Cross-Site Scripting. Read more about CSP here: https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP Missing Content-Security-Policy is flagged by sobelow when a pipeline implements the :put_secure_browser_headers plug, but does not provide a Content-Security-Policy header in the custom headers map. When it comes to CSP, just about any policy is better than none. If you are unsure about which policy to use, the following mitigates most typical XSS vectors: plug :put_secure_browser_headers, %{&quot;content-security-policy&quot; =&gt; &quot;default-src 'self'&quot;} Documentation on the put_secure_browser_headers plug function can be found here: https://hexdocs.pm/phoenix/Phoenix.Controller.html#put_secure_browser_headers/2 Content-Security-Policy checks can be ignored with the following command: $ mix sobelow -i Config.CSP","ref":"Sobelow.Config.CSP.html"},{"type":"function","title":"Sobelow.Config.CSP.check_vuln_pipeline/2","doc":"","ref":"Sobelow.Config.CSP.html#check_vuln_pipeline/2"},{"type":"function","title":"Sobelow.Config.CSP.details/0","doc":"","ref":"Sobelow.Config.CSP.html#details/0"},{"type":"function","title":"Sobelow.Config.CSP.id/0","doc":"","ref":"Sobelow.Config.CSP.html#id/0"},{"type":"function","title":"Sobelow.Config.CSP.rule/0","doc":"","ref":"Sobelow.Config.CSP.html#rule/0"},{"type":"function","title":"Sobelow.Config.CSP.run/1","doc":"","ref":"Sobelow.Config.CSP.html#run/1"},{"type":"module","title":"Sobelow.Config.CSRF","doc":"Cross-Site Request Forgery In a Cross-Site Request Forgery (CSRF) attack, an untrusted application can cause a user's browser to submit requests or perform actions on the user's behalf. Read more about CSRF here: https://owasp.org/www-community/attacks/csrf Cross-Site Request Forgery is flagged by sobelow when a pipeline fetches a session, but does not implement the :protect_from_forgery plug. CSRF checks can be ignored with the following command: $ mix sobelow -i Config.CSRF","ref":"Sobelow.Config.CSRF.html"},{"type":"function","title":"Sobelow.Config.CSRF.details/0","doc":"","ref":"Sobelow.Config.CSRF.html#details/0"},{"type":"function","title":"Sobelow.Config.CSRF.id/0","doc":"","ref":"Sobelow.Config.CSRF.html#id/0"},{"type":"function","title":"Sobelow.Config.CSRF.rule/0","doc":"","ref":"Sobelow.Config.CSRF.html#rule/0"},{"type":"function","title":"Sobelow.Config.CSRF.run/1","doc":"","ref":"Sobelow.Config.CSRF.html#run/1"},{"type":"module","title":"Sobelow.Config.CSRFRoute","doc":"Cross-Site Request Forgery In a Cross-Site Request Forgery (CSRF) attack, an untrusted application can cause a user's browser to submit requests or perform actions on the user's behalf. Read more about CSRF here: https://www.owasp.org/index.php/Cross-Site_Request_Forgery_(CSRF) This type of CSRF is flagged by sobelow when state-changing routes share an action with GET-based routes. For example: get &quot;/users&quot; , UserController , :new post &quot;/users&quot; , UserController , :new In this instance, it may be possible to trigger the POST functionality with a GET request and query parameters. CSRF checks can be ignored with the following command: $ mix sobelow -i Config.CSRFRoute","ref":"Sobelow.Config.CSRFRoute.html"},{"type":"function","title":"Sobelow.Config.CSRFRoute.combine_scopes/1","doc":"","ref":"Sobelow.Config.CSRFRoute.html#combine_scopes/1"},{"type":"function","title":"Sobelow.Config.CSRFRoute.details/0","doc":"","ref":"Sobelow.Config.CSRFRoute.html#details/0"},{"type":"function","title":"Sobelow.Config.CSRFRoute.id/0","doc":"","ref":"Sobelow.Config.CSRFRoute.html#id/0"},{"type":"function","title":"Sobelow.Config.CSRFRoute.route_findings/2","doc":"","ref":"Sobelow.Config.CSRFRoute.html#route_findings/2"},{"type":"function","title":"Sobelow.Config.CSRFRoute.rule/0","doc":"","ref":"Sobelow.Config.CSRFRoute.html#rule/0"},{"type":"function","title":"Sobelow.Config.CSRFRoute.run/1","doc":"","ref":"Sobelow.Config.CSRFRoute.html#run/1"},{"type":"module","title":"Sobelow.Config.CSWH","doc":"Cross-Site Websocket Hijacking Websocket connections are not bound by the same-origin policy. Connections that do not validate the origin may leak information to an attacker. More information can be found here: https://www.christian-schneider.net/CrossSiteWebSocketHijacking.html Cross-Site Websocket Hijacking checks can be disabled with the following command: $ mix sobelow -i Config.CSWH","ref":"Sobelow.Config.CSWH.html"},{"type":"function","title":"Sobelow.Config.CSWH.check_socket/1","doc":"","ref":"Sobelow.Config.CSWH.html#check_socket/1"},{"type":"function","title":"Sobelow.Config.CSWH.details/0","doc":"","ref":"Sobelow.Config.CSWH.html#details/0"},{"type":"function","title":"Sobelow.Config.CSWH.id/0","doc":"","ref":"Sobelow.Config.CSWH.html#id/0"},{"type":"function","title":"Sobelow.Config.CSWH.rule/0","doc":"","ref":"Sobelow.Config.CSWH.html#rule/0"},{"type":"function","title":"Sobelow.Config.CSWH.run/1","doc":"","ref":"Sobelow.Config.CSWH.html#run/1"},{"type":"module","title":"Sobelow.Config.HSTS","doc":"HSTS The HTTP Strict Transport Security (HSTS) header helps defend against man-in-the-middle attacks by preventing unencrypted connections. HSTS checks can be ignored with the following command: $ mix sobelow -i Config.HSTS","ref":"Sobelow.Config.HSTS.html"},{"type":"function","title":"Sobelow.Config.HSTS.details/0","doc":"","ref":"Sobelow.Config.HSTS.html#details/0"},{"type":"function","title":"Sobelow.Config.HSTS.id/0","doc":"","ref":"Sobelow.Config.HSTS.html#id/0"},{"type":"function","title":"Sobelow.Config.HSTS.rule/0","doc":"","ref":"Sobelow.Config.HSTS.html#rule/0"},{"type":"function","title":"Sobelow.Config.HSTS.run/2","doc":"","ref":"Sobelow.Config.HSTS.html#run/2"},{"type":"module","title":"Sobelow.Config.HTTPS","doc":"HTTPS Without HTTPS, attackers in a privileged network position can intercept and modify traffic. Sobelow detects missing HTTPS by checking the prod configuration. HTTPS checks can be ignored with the following command: $ mix sobelow -i Config.HTTPS","ref":"Sobelow.Config.HTTPS.html"},{"type":"function","title":"Sobelow.Config.HTTPS.details/0","doc":"","ref":"Sobelow.Config.HTTPS.html#details/0"},{"type":"function","title":"Sobelow.Config.HTTPS.id/0","doc":"","ref":"Sobelow.Config.HTTPS.html#id/0"},{"type":"function","title":"Sobelow.Config.HTTPS.rule/0","doc":"","ref":"Sobelow.Config.HTTPS.html#rule/0"},{"type":"function","title":"Sobelow.Config.HTTPS.run/2","doc":"","ref":"Sobelow.Config.HTTPS.html#run/2"},{"type":"module","title":"Sobelow.Config.Headers","doc":"Missing Secure HTTP Headers By default, Phoenix HTTP responses contain a number of secure HTTP headers that attempt to mitigate XSS, click-jacking, and content-sniffing attacks. Missing Secure HTTP Headers is flagged by sobelow when a pipeline accepts &quot;html&quot; requests, but does not implement the :put_secure_browser_headers plug. Secure Headers checks can be ignored with the following command: $ mix sobelow -i Config.Headers","ref":"Sobelow.Config.Headers.html"},{"type":"function","title":"Sobelow.Config.Headers.details/0","doc":"","ref":"Sobelow.Config.Headers.html#details/0"},{"type":"function","title":"Sobelow.Config.Headers.id/0","doc":"","ref":"Sobelow.Config.Headers.html#id/0"},{"type":"function","title":"Sobelow.Config.Headers.rule/0","doc":"","ref":"Sobelow.Config.Headers.html#rule/0"},{"type":"function","title":"Sobelow.Config.Headers.run/1","doc":"","ref":"Sobelow.Config.Headers.html#run/1"},{"type":"module","title":"Sobelow.Config.Secrets","doc":"Hard-coded Secrets In the event of a source-code disclosure via file read vulnerability, accidental commit, etc, hard-coded secrets may be exposed to an attacker. This may result in database access, cookie forgery, and other issues. Sobelow detects missing hard-coded secrets by checking the prod configuration. Hard-coded secrets checks can be ignored with the following command: $ mix sobelow -i Config.Secrets","ref":"Sobelow.Config.Secrets.html"},{"type":"function","title":"Sobelow.Config.Secrets.details/0","doc":"","ref":"Sobelow.Config.Secrets.html#details/0"},{"type":"function","title":"Sobelow.Config.Secrets.id/0","doc":"","ref":"Sobelow.Config.Secrets.html#id/0"},{"type":"function","title":"Sobelow.Config.Secrets.is_env_var?/1","doc":"","ref":"Sobelow.Config.Secrets.html#is_env_var?/1"},{"type":"function","title":"Sobelow.Config.Secrets.rule/0","doc":"","ref":"Sobelow.Config.Secrets.html#rule/0"},{"type":"function","title":"Sobelow.Config.Secrets.run/2","doc":"","ref":"Sobelow.Config.Secrets.html#run/2"},{"type":"module","title":"Sobelow.DOS","doc":"Denial of Service The Denial of Service (DOS) attack is focused on making a resource (site, application, server) unavailable for the purpose it was designed. Read more about Denial of Service here: https://owasp.org/www-community/attacks/Denial_of_Service If you wish to learn more about the specific vulnerabilities found within the Denial of Service category, you may run the following commands to find out more: $ mix sobelow - d DOS.StringToAtom $ mix sobelow - d DOS.ListToAtom $ mix sobelow - d DOS.BinToAtom Denial of Service checks of all types can be ignored with the following command: $ mix sobelow -i DOS","ref":"Sobelow.DOS.html"},{"type":"function","title":"Sobelow.DOS.details/0","doc":"","ref":"Sobelow.DOS.html#details/0"},{"type":"function","title":"Sobelow.DOS.finding_modules/0","doc":"","ref":"Sobelow.DOS.html#finding_modules/0"},{"type":"function","title":"Sobelow.DOS.get_vulns/4","doc":"","ref":"Sobelow.DOS.html#get_vulns/4"},{"type":"function","title":"Sobelow.DOS.rules/0","doc":"","ref":"Sobelow.DOS.html#rules/0"},{"type":"module","title":"Sobelow.DOS.BinToAtom","doc":"Denial of Service via Unsafe Atom Interpolation In Elixir, atoms are not garbage collected. As such, if user input is used to create atoms (as in :&quot;foo\#{bar}&quot; , or in :erlang.binary_to_atom ), it may result in memory exhaustion. Prefer the String.to_existing_atom function for untrusted user input. Atom interpolation checks can be ignored with the following command: $ mix sobelow -i DOS.BinToAtom","ref":"Sobelow.DOS.BinToAtom.html"},{"type":"function","title":"Sobelow.DOS.BinToAtom.details/0","doc":"","ref":"Sobelow.DOS.BinToAtom.html#details/0"},{"type":"function","title":"Sobelow.DOS.BinToAtom.id/0","doc":"","ref":"Sobelow.DOS.BinToAtom.html#id/0"},{"type":"function","title":"Sobelow.DOS.BinToAtom.parse_def/1","doc":"","ref":"Sobelow.DOS.BinToAtom.html#parse_def/1"},{"type":"function","title":"Sobelow.DOS.BinToAtom.rule/0","doc":"","ref":"Sobelow.DOS.BinToAtom.html#rule/0"},{"type":"function","title":"Sobelow.DOS.BinToAtom.run/2","doc":"","ref":"Sobelow.DOS.BinToAtom.html#run/2"},{"type":"module","title":"Sobelow.DOS.ListToAtom","doc":"Denial of Service via List.to_atom In Elixir, atoms are not garbage collected. As such, if user input is passed to the List.to_atom function, it may result in memory exhaustion. Prefer the List.to_existing_atom function for untrusted user input. List.to_atom checks can be ignored with the following command: $ mix sobelow -i DOS.ListToAtom","ref":"Sobelow.DOS.ListToAtom.html"},{"type":"function","title":"Sobelow.DOS.ListToAtom.details/0","doc":"","ref":"Sobelow.DOS.ListToAtom.html#details/0"},{"type":"function","title":"Sobelow.DOS.ListToAtom.id/0","doc":"","ref":"Sobelow.DOS.ListToAtom.html#id/0"},{"type":"function","title":"Sobelow.DOS.ListToAtom.parse_def/1","doc":"","ref":"Sobelow.DOS.ListToAtom.html#parse_def/1"},{"type":"function","title":"Sobelow.DOS.ListToAtom.rule/0","doc":"","ref":"Sobelow.DOS.ListToAtom.html#rule/0"},{"type":"function","title":"Sobelow.DOS.ListToAtom.run/2","doc":"","ref":"Sobelow.DOS.ListToAtom.html#run/2"},{"type":"module","title":"Sobelow.DOS.StringToAtom","doc":"Denial of Service via String.to_atom In Elixir, atoms are not garbage collected. As such, if user input is passed to the String.to_atom function, it may result in memory exhaustion. Prefer the String.to_existing_atom function for untrusted user input. String.to_atom checks can be ignored with the following command: $ mix sobelow -i DOS.StringToAtom","ref":"Sobelow.DOS.StringToAtom.html"},{"type":"function","title":"Sobelow.DOS.StringToAtom.details/0","doc":"","ref":"Sobelow.DOS.StringToAtom.html#details/0"},{"type":"function","title":"Sobelow.DOS.StringToAtom.id/0","doc":"","ref":"Sobelow.DOS.StringToAtom.html#id/0"},{"type":"function","title":"Sobelow.DOS.StringToAtom.parse_def/1","doc":"","ref":"Sobelow.DOS.StringToAtom.html#parse_def/1"},{"type":"function","title":"Sobelow.DOS.StringToAtom.rule/0","doc":"","ref":"Sobelow.DOS.StringToAtom.html#rule/0"},{"type":"function","title":"Sobelow.DOS.StringToAtom.run/2","doc":"","ref":"Sobelow.DOS.StringToAtom.html#run/2"},{"type":"module","title":"Sobelow.IO","doc":"IO helpers. Mostly mirror Mix.Shell.IO, but Mix will not always be available to Sobelow.","ref":"Sobelow.IO.html"},{"type":"function","title":"Sobelow.IO.error/1","doc":"","ref":"Sobelow.IO.html#error/1"},{"type":"function","title":"Sobelow.IO.info/1","doc":"","ref":"Sobelow.IO.html#info/1"},{"type":"function","title":"Sobelow.IO.yes?/1","doc":"","ref":"Sobelow.IO.html#yes?/1"},{"type":"module","title":"Sobelow.Misc","doc":"Miscellaneous This suite of tests is to be a catch-all for checks that don't fall neatly into the other detection categories. If you wish to learn more about the specific vulnerabilities found within the Miscellaneous category, you may run the following commands to find out more: $ mix sobelow - d Misc.BinToTerm Miscellaneous checks of all types can be ignored with the following command: $ mix sobelow -i Misc","ref":"Sobelow.Misc.html"},{"type":"function","title":"Sobelow.Misc.details/0","doc":"","ref":"Sobelow.Misc.html#details/0"},{"type":"function","title":"Sobelow.Misc.finding_modules/0","doc":"","ref":"Sobelow.Misc.html#finding_modules/0"},{"type":"function","title":"Sobelow.Misc.get_vulns/4","doc":"","ref":"Sobelow.Misc.html#get_vulns/4"},{"type":"function","title":"Sobelow.Misc.rules/0","doc":"","ref":"Sobelow.Misc.html#rules/0"},{"type":"module","title":"Sobelow.Misc.BinToTerm","doc":"Insecure use of binary_to_term If user input is passed to Erlang's binary_to_term function it may result in memory exhaustion or code execution. Even with the :safe option, binary_to_term will deserialize functions, and shouldn't be considered safe to use with untrusted input. binary_to_term checks can be ignored with the following command: $ mix sobelow -i Misc.BinToTerm","ref":"Sobelow.Misc.BinToTerm.html"},{"type":"function","title":"Sobelow.Misc.BinToTerm.details/0","doc":"","ref":"Sobelow.Misc.BinToTerm.html#details/0"},{"type":"function","title":"Sobelow.Misc.BinToTerm.id/0","doc":"","ref":"Sobelow.Misc.BinToTerm.html#id/0"},{"type":"function","title":"Sobelow.Misc.BinToTerm.parse_def/1","doc":"","ref":"Sobelow.Misc.BinToTerm.html#parse_def/1"},{"type":"function","title":"Sobelow.Misc.BinToTerm.rule/0","doc":"","ref":"Sobelow.Misc.BinToTerm.html#rule/0"},{"type":"function","title":"Sobelow.Misc.BinToTerm.run/2","doc":"","ref":"Sobelow.Misc.BinToTerm.html#run/2"},{"type":"module","title":"Sobelow.Misc.FilePath","doc":"Insecure use of File and Path Note: This check has been deprecated. File/Path issues were addressed with the release of OTP 21. In Elixir, File methods are null-terminated, while Path functions are not. This may cause security issues in certain situations. For example: user_input = &quot;/var/www/secret.txt \\0 /name&quot; path = Path . dirname ( user_input ) public_file = path &lt;&gt; &quot;/public.txt&quot; File . read ( public_file ) Because Path functions are not null-terminated, this will attempt to read the file, &quot;/var/www/secret.txt\\0/public.txt&quot;. However, due to the null-byte termination of File functions &quot;secret.txt&quot; will ultimately be read. File/Path checks can be ignored with the following command: $ mix sobelow -i Misc.FilePath","ref":"Sobelow.Misc.FilePath.html"},{"type":"module","title":"Sobelow.RCE","doc":"Remote Code Execution Remote Code Execution vulnerabilities are a result of untrusted user input being executed or interpreted by the system and may result in complete system compromise. If you wish to learn more about the specific vulnerabilities found within the Remote Code Execution category, you may run the following commands to find out more: $ mix sobelow - d RCE.EEx $ mix sobelow - d RCE.CodeModule Remote Code Execution checks of all types can be ignored with the following command: $ mix sobelow -i RCE","ref":"Sobelow.RCE.html"},{"type":"function","title":"Sobelow.RCE.details/0","doc":"","ref":"Sobelow.RCE.html#details/0"},{"type":"function","title":"Sobelow.RCE.finding_modules/0","doc":"","ref":"Sobelow.RCE.html#finding_modules/0"},{"type":"function","title":"Sobelow.RCE.get_vulns/4","doc":"","ref":"Sobelow.RCE.html#get_vulns/4"},{"type":"function","title":"Sobelow.RCE.rules/0","doc":"","ref":"Sobelow.RCE.html#rules/0"},{"type":"module","title":"Sobelow.RCE.CodeModule","doc":"Code Execution in eval function Arbitrary strings passed to the Code.eval_* functions can be executed as malicious code. Ensure the the code passed to the function is not user-controlled or remove the function call completely. Read more about Elixir RCE here: https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/sandboxing Code Execution checks can be ignored with the following command: $ mix sobelow -i RCE.CodeModule","ref":"Sobelow.RCE.CodeModule.html"},{"type":"function","title":"Sobelow.RCE.CodeModule.details/0","doc":"","ref":"Sobelow.RCE.CodeModule.html#details/0"},{"type":"function","title":"Sobelow.RCE.CodeModule.id/0","doc":"","ref":"Sobelow.RCE.CodeModule.html#id/0"},{"type":"function","title":"Sobelow.RCE.CodeModule.parse_def/2","doc":"","ref":"Sobelow.RCE.CodeModule.html#parse_def/2"},{"type":"function","title":"Sobelow.RCE.CodeModule.rule/0","doc":"","ref":"Sobelow.RCE.CodeModule.html#rule/0"},{"type":"function","title":"Sobelow.RCE.CodeModule.run/2","doc":"","ref":"Sobelow.RCE.CodeModule.html#run/2"},{"type":"module","title":"Sobelow.RCE.EEx","doc":"Insecure EEx evaluation If user input is passed to EEx eval functions, it may result in arbitrary code execution. The root cause of these issues is often directory traversal. EEx checks can be ignored with the following command: $ mix sobelow -i RCE.EEx","ref":"Sobelow.RCE.EEx.html"},{"type":"function","title":"Sobelow.RCE.EEx.details/0","doc":"","ref":"Sobelow.RCE.EEx.html#details/0"},{"type":"function","title":"Sobelow.RCE.EEx.id/0","doc":"","ref":"Sobelow.RCE.EEx.html#id/0"},{"type":"function","title":"Sobelow.RCE.EEx.parse_def/2","doc":"","ref":"Sobelow.RCE.EEx.html#parse_def/2"},{"type":"function","title":"Sobelow.RCE.EEx.rule/0","doc":"","ref":"Sobelow.RCE.EEx.html#rule/0"},{"type":"function","title":"Sobelow.RCE.EEx.run/2","doc":"","ref":"Sobelow.RCE.EEx.html#run/2"},{"type":"module","title":"Sobelow.SQL","doc":"SQL Injection SQL Injection occurs when untrusted input is interpolated directly into a SQL query. In a typical Phoenix application, this would mean using the Ecto.Adapters.SQL.query method and not using the parameterization feature. Read more about SQL injection here: https://www.owasp.org/index.php/SQL_Injection If you wish to learn more about the specific vulnerabilities found within the SQL Injection category, you may run the following commands to find out more: $ mix sobelow - d SQL.Query $ mix sobelow - d SQL.Stream SQL Injection checks of all types can be ignored with the following command: $ mix sobelow -i SQL","ref":"Sobelow.SQL.html"},{"type":"function","title":"Sobelow.SQL.details/0","doc":"","ref":"Sobelow.SQL.html#details/0"},{"type":"function","title":"Sobelow.SQL.finding_modules/0","doc":"","ref":"Sobelow.SQL.html#finding_modules/0"},{"type":"function","title":"Sobelow.SQL.get_vulns/4","doc":"","ref":"Sobelow.SQL.html#get_vulns/4"},{"type":"function","title":"Sobelow.SQL.rules/0","doc":"","ref":"Sobelow.SQL.html#rules/0"},{"type":"module","title":"Sobelow.SQL.Query","doc":"SQL Injection in Query This submodule of the SQL module checks for SQL injection vulnerabilities through usage of the Ecto.Adapters.SQL.query . Ensure that the query is parameterized and not user-controlled. SQLi Query checks can be ignored with the following command: $ mix sobelow -i SQL.Query","ref":"Sobelow.SQL.Query.html"},{"type":"function","title":"Sobelow.SQL.Query.details/0","doc":"","ref":"Sobelow.SQL.Query.html#details/0"},{"type":"function","title":"Sobelow.SQL.Query.id/0","doc":"","ref":"Sobelow.SQL.Query.html#id/0"},{"type":"function","title":"Sobelow.SQL.Query.parse_repo_query_def/1","doc":"","ref":"Sobelow.SQL.Query.html#parse_repo_query_def/1"},{"type":"function","title":"Sobelow.SQL.Query.parse_sql_def/1","doc":"","ref":"Sobelow.SQL.Query.html#parse_sql_def/1"},{"type":"function","title":"Sobelow.SQL.Query.rule/0","doc":"","ref":"Sobelow.SQL.Query.html#rule/0"},{"type":"function","title":"Sobelow.SQL.Query.run/2","doc":"","ref":"Sobelow.SQL.Query.html#run/2"},{"type":"module","title":"Sobelow.SQL.Stream","doc":"SQL Injection in Stream This submodule of the SQL module checks for SQL injection vulnerabilities through usage of the Ecto.Adapters.SQL.stream . Ensure that the query is parameterized and not user-controlled. SQLi Stream checks can be ignored with the following command: $ mix sobelow -i SQL.Stream","ref":"Sobelow.SQL.Stream.html"},{"type":"function","title":"Sobelow.SQL.Stream.details/0","doc":"","ref":"Sobelow.SQL.Stream.html#details/0"},{"type":"function","title":"Sobelow.SQL.Stream.id/0","doc":"","ref":"Sobelow.SQL.Stream.html#id/0"},{"type":"function","title":"Sobelow.SQL.Stream.parse_sql_def/1","doc":"","ref":"Sobelow.SQL.Stream.html#parse_sql_def/1"},{"type":"function","title":"Sobelow.SQL.Stream.rule/0","doc":"","ref":"Sobelow.SQL.Stream.html#rule/0"},{"type":"function","title":"Sobelow.SQL.Stream.run/2","doc":"","ref":"Sobelow.SQL.Stream.html#run/2"},{"type":"module","title":"Sobelow.Traversal","doc":"Path Traversal Path traversal vulnerabilities are a result of interacting with the filesystem using untrusted input. This class of vulnerability may result in file disclosure, code execution, denial of service, and other issues. Read more about Path Traversal here: https://www.owasp.org/index.php/Path_Traversal If you wish to learn more about the specific vulnerabilities found within the Path Traversal category, you may run the following commands to find out more: $ mix sobelow - d Traversal.SendFile $ mix sobelow - d Traversal.FileModule $ mix sobelow - d Traversal.SendDownload Path Traversal checks of all types can be ignored with the following command: $ mix sobelow -i Traversal","ref":"Sobelow.Traversal.html"},{"type":"function","title":"Sobelow.Traversal.details/0","doc":"","ref":"Sobelow.Traversal.html#details/0"},{"type":"function","title":"Sobelow.Traversal.finding_modules/0","doc":"","ref":"Sobelow.Traversal.html#finding_modules/0"},{"type":"function","title":"Sobelow.Traversal.get_vulns/4","doc":"","ref":"Sobelow.Traversal.html#get_vulns/4"},{"type":"function","title":"Sobelow.Traversal.rules/0","doc":"","ref":"Sobelow.Traversal.html#rules/0"},{"type":"module","title":"Sobelow.Traversal.FileModule","doc":"Directory Traversal in File function This submodule checks for directory traversal vulnerabilities in the File module. Ensure that the path passed to File functions is not user-controlled. File checks can be ignored with the following command: $ mix sobelow -i Traversal.FileModule","ref":"Sobelow.Traversal.FileModule.html"},{"type":"function","title":"Sobelow.Traversal.FileModule.details/0","doc":"","ref":"Sobelow.Traversal.FileModule.html#details/0"},{"type":"function","title":"Sobelow.Traversal.FileModule.id/0","doc":"","ref":"Sobelow.Traversal.FileModule.html#id/0"},{"type":"function","title":"Sobelow.Traversal.FileModule.parse_def/2","doc":"","ref":"Sobelow.Traversal.FileModule.html#parse_def/2"},{"type":"function","title":"Sobelow.Traversal.FileModule.parse_second_def/2","doc":"","ref":"Sobelow.Traversal.FileModule.html#parse_second_def/2"},{"type":"function","title":"Sobelow.Traversal.FileModule.rule/0","doc":"","ref":"Sobelow.Traversal.FileModule.html#rule/0"},{"type":"function","title":"Sobelow.Traversal.FileModule.run/2","doc":"","ref":"Sobelow.Traversal.FileModule.html#run/2"},{"type":"module","title":"Sobelow.Traversal.SendDownload","doc":"Directory Traversal in send_download This submodule checks for directory traversal vulnerabilities in the send_download function of a Phoenix Controller. Ensure that the path passed to send_download is not user-controlled. Send Download checks can be ignored with the following command: $ mix sobelow -i Traversal.SendDownload","ref":"Sobelow.Traversal.SendDownload.html"},{"type":"function","title":"Sobelow.Traversal.SendDownload.details/0","doc":"","ref":"Sobelow.Traversal.SendDownload.html#details/0"},{"type":"function","title":"Sobelow.Traversal.SendDownload.id/0","doc":"","ref":"Sobelow.Traversal.SendDownload.html#id/0"},{"type":"function","title":"Sobelow.Traversal.SendDownload.parse_def/1","doc":"","ref":"Sobelow.Traversal.SendDownload.html#parse_def/1"},{"type":"function","title":"Sobelow.Traversal.SendDownload.rule/0","doc":"","ref":"Sobelow.Traversal.SendDownload.html#rule/0"},{"type":"function","title":"Sobelow.Traversal.SendDownload.run/2","doc":"","ref":"Sobelow.Traversal.SendDownload.html#run/2"},{"type":"module","title":"Sobelow.Traversal.SendFile","doc":"Directory Traversal in send_file This submodule checks for directory traversal vulnerabilities in the send_file function. Ensure that the path passed to send_file is not user-controlled. Send File checks can be ignored with the following command: $ mix sobelow -i Traversal.SendFile","ref":"Sobelow.Traversal.SendFile.html"},{"type":"function","title":"Sobelow.Traversal.SendFile.details/0","doc":"","ref":"Sobelow.Traversal.SendFile.html#details/0"},{"type":"function","title":"Sobelow.Traversal.SendFile.id/0","doc":"","ref":"Sobelow.Traversal.SendFile.html#id/0"},{"type":"function","title":"Sobelow.Traversal.SendFile.parse_def/1","doc":"","ref":"Sobelow.Traversal.SendFile.html#parse_def/1"},{"type":"function","title":"Sobelow.Traversal.SendFile.rule/0","doc":"","ref":"Sobelow.Traversal.SendFile.html#rule/0"},{"type":"function","title":"Sobelow.Traversal.SendFile.run/2","doc":"","ref":"Sobelow.Traversal.SendFile.html#run/2"},{"type":"module","title":"Sobelow.Vuln","doc":"Known Vulnerable Dependencies An application with known vulnerabilities is more easily subjected to automated or targeted attacks. If you wish to learn more about the specific vulnerabilities found within the Known Vulnerable Dependencies category, you may run the following commands to find out more: $ mix sobelow - d Vuln.PlugNull $ mix sobelow - d Vuln.CookieRCE $ mix sobelow - d Vuln.HeaderInject $ mix sobelow - d Vuln.Redirect $ mix sobelow - d Vuln.Coherence $ mix sobelow - d Vuln.Ecto Known Vulnerable checks of all types can be ignored with the following command: $ mix sobelow -i Vuln","ref":"Sobelow.Vuln.html"},{"type":"function","title":"Sobelow.Vuln.details/0","doc":"","ref":"Sobelow.Vuln.html#details/0"},{"type":"function","title":"Sobelow.Vuln.finding_modules/0","doc":"","ref":"Sobelow.Vuln.html#finding_modules/0"},{"type":"function","title":"Sobelow.Vuln.get_vulns/1","doc":"","ref":"Sobelow.Vuln.html#get_vulns/1"},{"type":"function","title":"Sobelow.Vuln.print_finding/6","doc":"","ref":"Sobelow.Vuln.html#print_finding/6"},{"type":"function","title":"Sobelow.Vuln.rules/0","doc":"","ref":"Sobelow.Vuln.html#rules/0"},{"type":"module","title":"Sobelow.Vuln.Coherence","doc":"Coherence Version Vulnerable to Privilege Escalation For more information visit: https://github.com/advisories/GHSA-mrq8-53r4-3j5m Coherence checks can be ignored with the following command: $ mix sobelow -i Vuln.Coherence","ref":"Sobelow.Vuln.Coherence.html"},{"type":"function","title":"Sobelow.Vuln.Coherence.details/0","doc":"","ref":"Sobelow.Vuln.Coherence.html#details/0"},{"type":"function","title":"Sobelow.Vuln.Coherence.id/0","doc":"","ref":"Sobelow.Vuln.Coherence.html#id/0"},{"type":"function","title":"Sobelow.Vuln.Coherence.rule/0","doc":"","ref":"Sobelow.Vuln.Coherence.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.Coherence.run/1","doc":"","ref":"Sobelow.Vuln.Coherence.html#run/1"},{"type":"module","title":"Sobelow.Vuln.CookieRCE","doc":"Plug Version Vulnerable to Arbitrary Code Execution in Cookie Serialization For more information visit: https://github.com/advisories/GHSA-5v4m-c73v-c7gq Cookie RCE checks can be ignored with the following command: $ mix sobelow -i Vuln.CookieRCE","ref":"Sobelow.Vuln.CookieRCE.html"},{"type":"function","title":"Sobelow.Vuln.CookieRCE.details/0","doc":"","ref":"Sobelow.Vuln.CookieRCE.html#details/0"},{"type":"function","title":"Sobelow.Vuln.CookieRCE.id/0","doc":"","ref":"Sobelow.Vuln.CookieRCE.html#id/0"},{"type":"function","title":"Sobelow.Vuln.CookieRCE.rule/0","doc":"","ref":"Sobelow.Vuln.CookieRCE.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.CookieRCE.run/1","doc":"","ref":"Sobelow.Vuln.CookieRCE.html#run/1"},{"type":"module","title":"Sobelow.Vuln.Ecto","doc":"Ecto Version Lacks Protection Mechanism For more information visit: https://github.com/advisories/GHSA-2xxx-fhc8-9qvq Ecto checks can be ignored with the following command: $ mix sobelow -i Vuln.Ecto","ref":"Sobelow.Vuln.Ecto.html"},{"type":"function","title":"Sobelow.Vuln.Ecto.details/0","doc":"","ref":"Sobelow.Vuln.Ecto.html#details/0"},{"type":"function","title":"Sobelow.Vuln.Ecto.id/0","doc":"","ref":"Sobelow.Vuln.Ecto.html#id/0"},{"type":"function","title":"Sobelow.Vuln.Ecto.rule/0","doc":"","ref":"Sobelow.Vuln.Ecto.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.Ecto.run/1","doc":"","ref":"Sobelow.Vuln.Ecto.html#run/1"},{"type":"module","title":"Sobelow.Vuln.HeaderInject","doc":"Plug Version Vulnerable to Header Injection For more information visit: https://github.com/advisories/GHSA-9h73-w7ch-rh73 Header Injection checks can be ignored with the following command: $ mix sobelow -i Vuln.HeaderInject","ref":"Sobelow.Vuln.HeaderInject.html"},{"type":"function","title":"Sobelow.Vuln.HeaderInject.details/0","doc":"","ref":"Sobelow.Vuln.HeaderInject.html#details/0"},{"type":"function","title":"Sobelow.Vuln.HeaderInject.id/0","doc":"","ref":"Sobelow.Vuln.HeaderInject.html#id/0"},{"type":"function","title":"Sobelow.Vuln.HeaderInject.rule/0","doc":"","ref":"Sobelow.Vuln.HeaderInject.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.HeaderInject.run/1","doc":"","ref":"Sobelow.Vuln.HeaderInject.html#run/1"},{"type":"module","title":"Sobelow.Vuln.PlugNull","doc":"Plug Version Vulnerable to Null Byte Injection For more information visit: https://github.com/advisories/GHSA-2q6v-32mr-8p8x Null Byte Injection checks can be ignored with the following command: $ mix sobelow -i Vuln.PlugNull","ref":"Sobelow.Vuln.PlugNull.html"},{"type":"function","title":"Sobelow.Vuln.PlugNull.details/0","doc":"","ref":"Sobelow.Vuln.PlugNull.html#details/0"},{"type":"function","title":"Sobelow.Vuln.PlugNull.id/0","doc":"","ref":"Sobelow.Vuln.PlugNull.html#id/0"},{"type":"function","title":"Sobelow.Vuln.PlugNull.rule/0","doc":"","ref":"Sobelow.Vuln.PlugNull.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.PlugNull.run/1","doc":"","ref":"Sobelow.Vuln.PlugNull.html#run/1"},{"type":"module","title":"Sobelow.Vuln.Redirect","doc":"Phoenix Version Vulnerable to Arbitrary URL Redirection For more information visit: https://github.com/advisories/GHSA-cmfh-8f8r-fj96 URL Redirection checks can be ignored with the following command: $ mix sobelow -i Vuln.Redirect","ref":"Sobelow.Vuln.Redirect.html"},{"type":"function","title":"Sobelow.Vuln.Redirect.details/0","doc":"","ref":"Sobelow.Vuln.Redirect.html#details/0"},{"type":"function","title":"Sobelow.Vuln.Redirect.id/0","doc":"","ref":"Sobelow.Vuln.Redirect.html#id/0"},{"type":"function","title":"Sobelow.Vuln.Redirect.rule/0","doc":"","ref":"Sobelow.Vuln.Redirect.html#rule/0"},{"type":"function","title":"Sobelow.Vuln.Redirect.run/1","doc":"","ref":"Sobelow.Vuln.Redirect.html#run/1"},{"type":"module","title":"Sobelow.XSS","doc":"Cross-Site Scripting Cross-Site Scripting (XSS) vulnerabilities are a result of rendering untrusted input on a page without proper encoding. XSS may allow an attacker to perform actions on behalf of other users, steal session tokens, or access private data. Read more about XSS here: https://www.owasp.org/index.php/Cross-site_Scripting_(XSS) If you wish to learn more about the specific vulnerabilities found within the Cross-Site Scripting category, you may run the following commands to find out more: $ mix sobelow - d XSS.SendResp $ mix sobelow - d XSS.ContentType $ mix sobelow - d XSS.Raw $ mix sobelow - d XSS.HTML XSS checks of all types can be ignored with the following command: $ mix sobelow -i XSS","ref":"Sobelow.XSS.html"},{"type":"function","title":"Sobelow.XSS.details/0","doc":"","ref":"Sobelow.XSS.html#details/0"},{"type":"function","title":"Sobelow.XSS.finding_modules/0","doc":"","ref":"Sobelow.XSS.html#finding_modules/0"},{"type":"function","title":"Sobelow.XSS.get_template_vulns/1","doc":"","ref":"Sobelow.XSS.html#get_template_vulns/1"},{"type":"function","title":"Sobelow.XSS.get_vulns/4","doc":"","ref":"Sobelow.XSS.html#get_vulns/4"},{"type":"function","title":"Sobelow.XSS.rules/0","doc":"","ref":"Sobelow.XSS.html#rules/0"},{"type":"module","title":"Sobelow.XSS.ContentType","doc":"XSS in put_resp_content_type If an attacker is able to set arbitrary content types for an HTTP response containing user input, the attacker is likely to be able to leverage this for cross-site scripting (XSS). For example, consider an endpoint that returns JSON with user input: { &quot;json&quot; : &quot;user_input&quot; } If an attacker can control the content type set in the HTTP response, they can set it to &quot;text/html&quot; and update the JSON to the following in order to cause XSS: { &quot;json&quot; : &quot;&lt;script&gt;alert(document.domain)&lt;/script&gt;&quot; } Content Type checks can be ignored with the following command: $ mix sobelow -i XSS.ContentType","ref":"Sobelow.XSS.ContentType.html"},{"type":"function","title":"Sobelow.XSS.ContentType.details/0","doc":"","ref":"Sobelow.XSS.ContentType.html#details/0"},{"type":"function","title":"Sobelow.XSS.ContentType.id/0","doc":"","ref":"Sobelow.XSS.ContentType.html#id/0"},{"type":"function","title":"Sobelow.XSS.ContentType.parse_def/1","doc":"","ref":"Sobelow.XSS.ContentType.html#parse_def/1"},{"type":"function","title":"Sobelow.XSS.ContentType.rule/0","doc":"","ref":"Sobelow.XSS.ContentType.html#rule/0"},{"type":"function","title":"Sobelow.XSS.ContentType.run/2","doc":"","ref":"Sobelow.XSS.ContentType.html#run/2"},{"type":"module","title":"Sobelow.XSS.HTML","doc":"XSS in html This submodule looks for XSS vulnerabilities in html calls from the Phoenix Controller. HTML checks can be ignored with the following command: $ mix sobelow -i XSS.HTML","ref":"Sobelow.XSS.HTML.html"},{"type":"function","title":"Sobelow.XSS.HTML.details/0","doc":"","ref":"Sobelow.XSS.HTML.html#details/0"},{"type":"function","title":"Sobelow.XSS.HTML.id/0","doc":"","ref":"Sobelow.XSS.HTML.html#id/0"},{"type":"function","title":"Sobelow.XSS.HTML.parse_def/1","doc":"","ref":"Sobelow.XSS.HTML.html#parse_def/1"},{"type":"function","title":"Sobelow.XSS.HTML.rule/0","doc":"","ref":"Sobelow.XSS.HTML.html#rule/0"},{"type":"function","title":"Sobelow.XSS.HTML.run/2","doc":"","ref":"Sobelow.XSS.HTML.html#run/2"},{"type":"module","title":"Sobelow.XSS.Raw","doc":"XSS in raw This submodule checks for the use of raw in templates as this can lead to XSS vulnerabilities if taking user input. Raw checks can be ignored with the following command: $ mix sobelow -i XSS.Raw","ref":"Sobelow.XSS.Raw.html"},{"type":"function","title":"Sobelow.XSS.Raw.details/0","doc":"","ref":"Sobelow.XSS.Raw.html#details/0"},{"type":"function","title":"Sobelow.XSS.Raw.id/0","doc":"","ref":"Sobelow.XSS.Raw.html#id/0"},{"type":"function","title":"Sobelow.XSS.Raw.parse_raw_def/1","doc":"","ref":"Sobelow.XSS.Raw.html#parse_raw_def/1"},{"type":"function","title":"Sobelow.XSS.Raw.parse_render_def/1","doc":"","ref":"Sobelow.XSS.Raw.html#parse_render_def/1"},{"type":"function","title":"Sobelow.XSS.Raw.rule/0","doc":"","ref":"Sobelow.XSS.Raw.html#rule/0"},{"type":"function","title":"Sobelow.XSS.Raw.run/4","doc":"","ref":"Sobelow.XSS.Raw.html#run/4"},{"type":"module","title":"Sobelow.XSS.SendResp","doc":"XSS in send_resp This submodule looks for XSS vulnerabilities in the body argument of Conn.send_resp . SendResp checks can be ignored with the following command: $ mix sobelow -i XSS.SendResp","ref":"Sobelow.XSS.SendResp.html"},{"type":"function","title":"Sobelow.XSS.SendResp.details/0","doc":"","ref":"Sobelow.XSS.SendResp.html#details/0"},{"type":"function","title":"Sobelow.XSS.SendResp.id/0","doc":"","ref":"Sobelow.XSS.SendResp.html#id/0"},{"type":"function","title":"Sobelow.XSS.SendResp.parse_def/1","doc":"","ref":"Sobelow.XSS.SendResp.html#parse_def/1"},{"type":"function","title":"Sobelow.XSS.SendResp.rule/0","doc":"","ref":"Sobelow.XSS.SendResp.html#rule/0"},{"type":"function","title":"Sobelow.XSS.SendResp.run/2","doc":"","ref":"Sobelow.XSS.SendResp.html#run/2"},{"type":"extras","title":"Sobelow","doc":"Sobelow is a security-focused static analysis tool for Elixir &amp; the Phoenix framework. For security researchers, it is a useful tool for getting a quick view of points-of-interest. For project maintainers, it can be used to prevent the introduction of a number of common vulnerabilities. Currently Sobelow detects some types of the following security issues: Insecure configuration Known-vulnerable Dependencies Cross-Site Scripting SQL injection Command injection Code execution Denial of Service Directory traversal Unsafe serialization Potential vulnerabilities are flagged in different colors according to confidence in their insecurity. High confidence is red, medium confidence is yellow, and low confidence is green. A finding is typically marked &quot;low confidence&quot; if it looks like a function could be used insecurely, but it cannot reliably be determined if the function accepts user-supplied input. i.e. If a finding is marked green, it may be critically insecure, but it will require greater manual validation. Note: This project is in constant development, and additional vulnerabilities will be flagged as time goes on. If you encounter a bug, or would like to request additional features or security checks, please open an issue!","ref":"readme.html"},{"type":"extras","title":"Sobelow - Table of Contents","doc":"Installation To Use Options Configuration Files False Positives Modules Umbrella Apps Updates","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Sobelow - Installation","doc":"To use Sobelow, you can add it to your application's dependencies. def deps do [ { :sobelow , &quot;~&gt; 0.13&quot; , only : [ :dev , :test ] , runtime : false } ] end You can also install Sobelow globally by executing the following from the command line: $ mix escript.install hex sobelow To install from the master branch, rather than the latest release, the following command can be used: $ mix escript.install github nccgroup/sobelow To Use After installation, the simplest way to scan a Phoenix project is to run the following from the project root: $ mix sobelow","ref":"readme.html#installation"},{"type":"extras","title":"Sobelow - Options","doc":"Note: Any path arguments should be absolute paths, or relative to the application root. --root or -r - Specify the application root directory. Accepts a path argument, e.g. ../my_project . --verbose or -v - Print code snippets and additional finding details. --ignore or -i - Ignore given finding types. Accepts a comma-separated list of module names, e.g. XSS.Raw,Traversal . --ignore-files - Ignore files. Accepts a comma-separated list of file names, e.g. config/prod.exs . --details or -d - Get finding-type details. Accepts a single module name, e.g. Config.CSRF . --all-details - Get details of all finding-types. --private - Skip update checks. --router - Specify router location. This only needs to be used if the router location is non-standard. Accepts a path argument, e.g. my/strange/router.ex . --exit - Return non-zero exit status at or above a confidence threshold of low , medium , or high . Defaults to false which returns a zero exit status --threshold - Return findings at or above a confidence level of low (default), medium , or high . --format or -f - Specify findings output format. Accepts a format, e.g. txt or json . Note that options such as --verbose will not work with the json format. All json formatted findings contain a type , file , and line key. Other keys may vary. --quiet - Return a single line indicating number of findings. Otherwise, return no output if there are no findings. --compact - Minimal, single-line findings with output colorised according to confidence. --flycheck - Minimal, single-line findings that are compatible with flycheck-based tooling. --save-config - Generates a configuration file based on command line options. See Configuration Files for more information. --config - Run Sobelow with configuration file. See Configuration Files for more information. --mark-skip-all - Mark all displayed findings as skippable. --clear-skip - Clear configuration created by --mark-skip-all . --skip - Ignore findings that have been marked for skipping. See False Positives for more information. --version - Outputs the current version of Sobelow. This is useful for CI steps or integration with other tools like Salus .","ref":"readme.html#options"},{"type":"extras","title":"Sobelow - Configuration Files","doc":"Sobelow allows users to save frequently used options in a configuration file. For example, if you find yourself constantly running: $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low You can use the --save-config flag to create your .sobelow-conf config file: $ mix sobelow -i XSS.Raw,Traversal --verbose --exit Low --save-config This command will create the .sobelow-conf file at the root of your application. You can edit this file directly to make changes. You can also run the command without any options: $ mix sobelow --save-config when you first start out using this package - the generated configuration file will be populated with the default values for each option. (This helps in quickly incorporating this package into a pre-existing codebase.) Now if you want to run Sobelow with the saved configuration, you can run Sobelow with the --config flag. $ mix sobelow --config","ref":"readme.html#configuration-files"},{"type":"extras","title":"Sobelow - False Positives","doc":"Sobelow favors over-reporting versus under-reporting. As such, you may find a number of false positives in a typical scan. These findings may be individually ignored by adding a # sobelow_skip comment, along with a list of modules, before the function definition. # sobelow_skip [&quot;Traversal&quot;] def vuln_func ( ... ) do ... end When integrating Sobelow into a new project, there can be a large number of false positives. To mark all printed findings as false positives, run sobelow with the --mark-skip-all flag. Once you have tagged the appropriate findings, run Sobelow with the --skip flag. $ mix sobelow --skip While # sobelow_skip comments can only mark function-level findings (and so cannot be used to skip configuration issues), the --mark-skip-all flag can be used to skip any finding type.","ref":"readme.html#false-positives"},{"type":"extras","title":"Sobelow - Modules","doc":"Findings categories are broken up into modules. These modules can then be used to either ignore classes of findings (via the ignore and skip options) or to get vulnerability details (via the details option). This list, and other helpful information, can be found on the command line: $ mix help sobelow","ref":"readme.html#modules"},{"type":"extras","title":"Sobelow - Umbrella Apps","doc":"In order to run Sobelow against all child apps within an umbrella app with a single command, you can add an alias for sobelow in your root mix.exs file: defp aliases do [ sobelow : [ &quot;cmd mix sobelow&quot; ] ] end If you wish to use configuration files in an umbrella app, create a .sobelow-conf in each child application and use the --config flag.","ref":"readme.html#umbrella-apps"},{"type":"extras","title":"Sobelow - Updates","doc":"When scanning a project, Sobelow will occasionally check for updates, and will print an alert if a new version is available. Sobelow keeps track of the last update-check by creating a .sobelow file in the root of the scanned project. If this functionality is not desired, the --private flag can be used with the scan.","ref":"readme.html#updates"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - v0.13.0","doc":"Removed Support for minimum Elixir versions 1.5 &amp; 1.6 ( POTENTIALLY BREAKING - only applies if you relied on Elixir 1.5 or 1.6, 1.7+ is still supported) Enhancements Fixed all credo warnings Implemented all credo &quot;Code Readability&quot; adjustments Took advantage of some credo refactoring opportunities Added (sub)module documentation that was missing for some vulnerabilities and unified presentation of others Bug fixes Fixed --details / -d not displaying correct information Fixed incompatibility issue with Elixir 1.15 Misc Added mix credo --strict to project Improvements to GitHub CI Hex Audit Compiler Warnings as Errors Checks Formatting Added helper mix test.all alias","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"Changelog - v0.12.2","doc":"Bug fixes Removed :castore and introduced :verify_none to quiet warning and unblock escript usage, see #133 for more context on why this is necessary","ref":"changelog.html#v0-12-2"},{"type":"extras","title":"Changelog - v0.12.1","doc":"Bug fixes Lowered required version of :castore to remove upgrade path issues Reconfigured :verify_peer to actually use CAStore and remove warning","ref":"changelog.html#v0-12-1"},{"type":"extras","title":"Changelog - v0.12.0","doc":"Removed Support for minimum Elixir version 1.4 ( POTENTIALLY BREAKING - only applies if you relied on Elixir 1.4, 1.5+ is still supported) Enhancements Adds support for HEEx to XSS.Raw Adds --version CLI flag README Improvements Umbrella App usage Clearer installation process Layout changes Updated dependencies Bug fixes Adds to_string() to exit_on Sets SSL opt verify_peer in version check Reworks -v, --verbose printing to not use the now deprecated Macro.to_string/2 Misc Allows atom values for threshold in config file Uses SPDX ID for licenses in mixfile Fixed typo","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"Changelog - v0.11.2","doc":"Enhancements Simplify --flycheck output to align with expected format","ref":"changelog.html#v0-11-2"},{"type":"extras","title":"Changelog - v0.11.1","doc":"Enhancements Sarif output with --out flag --strict flag, which throws compilation errors instead of suppressing them.","ref":"changelog.html#v0-11-1"},{"type":"extras","title":"Changelog - v0.11.0","doc":"Enhancements Sarif output for GitHub integration --flycheck flag, which reverses output of --compact Bug fixes Non-compiling files now return an empty syntax tree instead of causing Sobelow errors. Command Injection finding description are properly formatted Misc If you use Sobelow as a standalone utility (i.e. not as part of a Phoenix application), you now need to install as an escript with mix escript.install hex sobelow . Custom JSON serialization replaced with Jason.","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"Changelog - v0.10.6","doc":"Bug fixes Handle nil config case","ref":"changelog.html#v0-10-6"},{"type":"extras","title":"Changelog - v0.10.5","doc":"Misc Update code to clean up deprecation warnings","ref":"changelog.html#v0-10-5"},{"type":"extras","title":"Changelog - v0.10.4","doc":"Enhancements Sobelow is now smarter about cross-site websocket hijacking Update URL for CSRF description","ref":"changelog.html#v0-10-4"},{"type":"extras","title":"Changelog - v0.10.3","doc":"Bug fixes Fix directory structure issue in umbrella applications Handle function capture edge cases","ref":"changelog.html#v0-10-3"},{"type":"extras","title":"Changelog - v0.10.2","doc":"Bug fixes Fix a format error in JSON output encoding","ref":"changelog.html#v0-10-2"},{"type":"extras","title":"Changelog - v0.10.1","doc":"Bug fixes Sobelow will use &quot;.sobelow-skips&quot; instead of &quot;.sobelow&quot; in your root directory for --mark-skip-all","ref":"changelog.html#v0-10-1"},{"type":"extras","title":"Changelog - v0.10.0","doc":"Enhancements Sobelow now uses &quot;~/.sobelow/sobelow-vsn-check&quot; for update checks The &quot;.sobelow&quot; file in your project root is for --mark-skip-all only","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"Changelog - v0.9.3","doc":"Enhancements Improved checks for all aliased functions Bug Fixes JSON output for Raw findings is now properly normalized send_download correctly flags aliased function calls send_download now correctly flags piped functions","ref":"changelog.html#v0-9-3"},{"type":"extras","title":"Changelog - v0.9.2","doc":"Bug Fixes Fix error that resulted from redefining imported functions","ref":"changelog.html#v0-9-2"},{"type":"extras","title":"Changelog - v0.9.1","doc":"Bug Fixes Revert umbrella app recursion","ref":"changelog.html#v0-9-1"},{"type":"extras","title":"Changelog - v0.9.0","doc":"Enhancements Add --mark-skip-all and --clear-skip flags New CSRF via action reuse checks Sobelow can now be run in umbrella apps Bug Fixes Fix an error when printing some kinds of variables","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"Changelog - v0.8.0","doc":"Enhancements Improve output consistency All JSON findings contain type , file , and line keys &quot;Line&quot; output now refers directly to the vulnerable line Default output headers have been normalized Note: If you depend on the structure of the output, this may be a breaking change. More information can be found at https://sobelow.io .","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"Changelog - v0.7.8","doc":"Enhancements Add --threshold flag Add module names to finding output Deprecations File/Path check has been deprecated Bug Fixes Fix inaccurate CSRF details","ref":"changelog.html#v0-7-8"},{"type":"extras","title":"Changelog - v0.7.7","doc":"Enhancements Add check for insecure websocket settings Bug Fixes Accept module attributes for application name","ref":"changelog.html#v0-7-7"},{"type":"extras","title":"Changelog - v0.7.6","doc":"Bug Fixes Fix issue that suppressed output options when config files were in use","ref":"changelog.html#v0-7-6"},{"type":"extras","title":"Changelog - v0.7.5","doc":"Misc Sobelow will now only halt when --exit flag is used","ref":"changelog.html#v0-7-5"},{"type":"extras","title":"Changelog - v0.7.4","doc":"Bug Fixes Log hardcoded secrets for txt output","ref":"changelog.html#v0-7-4"},{"type":"extras","title":"Changelog - v0.7.3","doc":"Misc Tweaks to --out flag.","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"Changelog - v0.7.2","doc":"Enhancements Add router path to config findings Add --out flag for writing to file","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"Changelog - v0.7.1","doc":"Enhancements Improved handling of JSON format Additional checks for File functions","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"Changelog - v0.7.0","doc":"Enhancements Improved handling of vulnerabilities within templates. Bug Fixes Sobelow no longer incorrectly flags :binary send_download functions.","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"Changelog - v0.6.9","doc":"Enhancements Improve template parsing and validation. Support multiple routers, and improve route discovery. Misc. Update language for missing directory.","ref":"changelog.html#v0-6-9"},{"type":"extras","title":"Changelog - v0.6.8","doc":"Bug Fixes Fix bug in the handling of certain piped functions. Revert not/in update that broke Elixir 1.4 compatibility.","ref":"changelog.html#v0-6-8"},{"type":"extras","title":"Changelog - v0.6.7","doc":"Enhancements Remove banner print from JSON format. Bug Fixes Fix error that occurred with certain function names in JSON format.","ref":"changelog.html#v0-6-7"},{"type":"extras","title":"Changelog - v0.6.6","doc":"Enhancements Add check for directory traversal via send_download Add check for missing Content-Security-Policy Check additional XSS vectors","ref":"changelog.html#v0-6-6"},{"type":"extras","title":"Changelog - v0.6.5","doc":"Bug Fixes Allow RCE module to be appropriately ignored.","ref":"changelog.html#v0-6-5"},{"type":"extras","title":"Changelog - v0.6.4","doc":"Enhancements Set timeout for version check.","ref":"changelog.html#v0-6-4"},{"type":"extras","title":"Changelog - v0.6.3","doc":"Enhancements Add RCE module to check for code execution via Code and EEx . Deprecations The --with-code flag has been changed to --verbose . The --with-code flag will continue to work as expected until v1.0.0, but will print a warning message.","ref":"changelog.html#v0-6-3"}]